package com.zcloud.zcGbsServicer.web;


import com.zcloud.zcGbsServicer.api.ControlRoomServiceI;
import com.zcloud.zcGbsServicer.dto.ControlRoomAddCmd;
import com.zcloud.zcGbsServicer.dto.ControlRoomPageQry;
import com.zcloud.zcGbsServicer.dto.ControlRoomUpdateCmd;
import com.zcloud.zcGbsServicer.dto.clientobject.ControlRoomCO;
import com.alibaba.cola.dto.MultiResponse;
import com.alibaba.cola.dto.PageResponse;
import com.alibaba.cola.dto.Response;
import com.alibaba.cola.dto.SingleResponse;
import com.jjb.saas.framework.auth.model.SSOUser;
import com.jjb.saas.framework.auth.utils.AuthContext;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
/**
* web-adapter
* @Author makejava
* @Date 2026-01-21 17:21:47
*/
@Api(tags = "消防控制室")
@RequestMapping("/${application.gateway}/controlRoom")
@RestController
@AllArgsConstructor
public class ControlRoomController {
    private final ControlRoomServiceI controlRoomService;

    @ApiOperation("新增")
    @PostMapping("/save")
    public SingleResponse<ControlRoomCO> add(@Validated @RequestBody ControlRoomAddCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        return controlRoomService.add(cmd);
    }

    @ApiOperation("分页")
    @PostMapping("/list")
    public PageResponse<ControlRoomCO> page(@RequestBody ControlRoomPageQry qry) {
        return controlRoomService.listPage(qry);
    }

    @ApiOperation("所有数据")
    @GetMapping("/listAll")
    public MultiResponse<ControlRoomCO> listAll() {
        return MultiResponse.of(new ArrayList<ControlRoomCO>());
    }

    @ApiOperation("详情")
    @GetMapping("/{id}")
    public SingleResponse<ControlRoomCO> getInfoById(@PathVariable("id") Long id) {
        return SingleResponse.of(new ControlRoomCO());
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public Response remove(@PathVariable("id") Long id) {
        controlRoomService.remove(id);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("删除多个")
    @DeleteMapping("/ids")
        public Response removeBatch(@RequestParam Long[] ids) {
        controlRoomService.removeBatch(ids);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("修改")
    @PutMapping("/edit")
    public SingleResponse edit(@Validated @RequestBody ControlRoomUpdateCmd controlRoomUpdateCmd) {
        controlRoomService.edit(controlRoomUpdateCmd);
        return SingleResponse.buildSuccess();
    }
}

